test-lib.sh 20.7 KB
Newer Older
1 2 3 4
#!/bin/sh
#
# Copyright (c) 2005 Junio C Hamano
#
5 6 7 8 9 10 11 12 13 14 15 16
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see http://www.gnu.org/licenses/ .
17

18 19 20 21 22 23
# if --tee was passed, write the output not only to the terminal, but
# additionally to the file test-results/$BASENAME.out, too.
case "$GIT_TEST_TEE_STARTED, $* " in
done,*)
	# do not redirect again
	;;
24
*' --tee '*|*' --va'*)
25 26 27 28 29 30 31 32 33
	mkdir -p test-results
	BASE=test-results/$(basename "$0" .sh)
	(GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
	 echo $? > $BASE.exit) | tee $BASE.out
	test "$(cat $BASE.exit)" = 0
	exit
	;;
esac

34 35 36
# Keep the original TERM for say_color
ORIGINAL_TERM=$TERM

37 38
# For repeatability, reset the environment to known value.
LANG=C
39
LC_ALL=C
40
PAGER=cat
41
TZ=UTC
42 43
TERM=dumb
export LANG LC_ALL PAGER TERM TZ
44
EDITOR=:
45
unset VISUAL
46
unset GIT_EDITOR
47 48 49 50 51
unset AUTHOR_DATE
unset AUTHOR_EMAIL
unset AUTHOR_NAME
unset COMMIT_AUTHOR_EMAIL
unset COMMIT_AUTHOR_NAME
52
unset EMAIL
53 54
unset GIT_ALTERNATE_OBJECT_DIRECTORIES
unset GIT_AUTHOR_DATE
55 56
GIT_AUTHOR_EMAIL=author@example.com
GIT_AUTHOR_NAME='A U Thor'
57
unset GIT_COMMITTER_DATE
58 59
GIT_COMMITTER_EMAIL=committer@example.com
GIT_COMMITTER_NAME='C O Mitter'
60 61
unset GIT_DIFF_OPTS
unset GIT_DIR
62
unset GIT_WORK_TREE
63 64 65
unset GIT_EXTERNAL_DIFF
unset GIT_INDEX_FILE
unset GIT_OBJECT_DIRECTORY
66
unset GIT_CEILING_DIRECTORIES
67 68
unset SHA1_FILE_DIRECTORIES
unset SHA1_FILE_DIRECTORY
69
unset GIT_NOTES_REF
70
unset GIT_NOTES_DISPLAY_REF
71 72
unset GIT_NOTES_REWRITE_REF
unset GIT_NOTES_REWRITE_MODE
73 74
GIT_MERGE_VERBOSITY=5
export GIT_MERGE_VERBOSITY
75 76
export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
77
export EDITOR
78

79 80 81 82
# Protect ourselves from common misconfiguration to export
# CDPATH into the environment
unset CDPATH

B
Bert Wesarg 已提交
83 84
unset GREP_OPTIONS

85
case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
86 87 88 89 90 91 92 93
	1|2|true)
		echo "* warning: Some tests will not work if GIT_TRACE" \
			"is set as to trace on STDERR ! *"
		echo "* warning: Please set GIT_TRACE to something" \
			"other than 1, 2 or true ! *"
		;;
esac

94 95 96 97 98 99
# Convenience
#
# A regexp to match 5 and 40 hexdigits
_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"

100 101 102 103 104 105
# Each test should start with something like this, after copyright notices:
#
# test_description='Description of this test...
# This test checks if command xyzzy does the right thing...
# '
# . ./test-lib.sh
106 107 108 109 110 111 112 113
[ "x$ORIGINAL_TERM" != "xdumb" ] && (
		TERM=$ORIGINAL_TERM &&
		export TERM &&
		[ -t 1 ] &&
		tput bold >/dev/null 2>&1 &&
		tput setaf 1 >/dev/null 2>&1 &&
		tput sgr0 >/dev/null 2>&1
	) &&
114
	color=t
115 116 117 118 119 120

while test "$#" -ne 0
do
	case "$1" in
	-d|--d|--de|--deb|--debu|--debug)
		debug=t; shift ;;
J
Junio C Hamano 已提交
121 122
	-i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
		immediate=t; shift ;;
123
	-l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
J
Junio C Hamano 已提交
124
		GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
125
	-h|--h|--he|--hel|--help)
126
		help=t; shift ;;
127 128
	-v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
		verbose=t; shift ;;
129 130
	-q|--q|--qu|--qui|--quie|--quiet)
		quiet=t; shift ;;
131 132
	--with-dashes)
		with_dashes=t; shift ;;
133
	--no-color)
134
		color=; shift ;;
135
	--no-python)
J
Junio C Hamano 已提交
136 137
		# noop now...
		shift ;;
138
	--va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
139
		valgrind=t; verbose=t; shift ;;
140 141
	--tee)
		shift ;; # was handled already
142 143 144
	--root=*)
		root=$(expr "z$1" : 'z[^=]*=\(.*\)')
		shift ;;
145
	*)
146
		echo "error: unknown test option '$1'" >&2; exit 1 ;;
147 148 149
	esac
done

150 151
if test -n "$color"; then
	say_color () {
152 153 154
		(
		TERM=$ORIGINAL_TERM
		export TERM
155 156 157 158 159
		case "$1" in
			error) tput bold; tput setaf 1;; # bold red
			skip)  tput bold; tput setaf 2;; # bold green
			pass)  tput setaf 2;;            # green
			info)  tput setaf 3;;            # brown
160
			*) test -n "$quiet" && return;;
161 162
		esac
		shift
163
		printf "%s" "$*"
164
		tput sgr0
165
		echo
166
		)
167 168 169
	}
else
	say_color() {
170
		test -z "$1" && test -n "$quiet" && return
171
		shift
172
		echo "$*"
173 174 175 176 177
	}
fi

error () {
	say_color error "error: $*"
178
	GIT_EXIT_OK=t
179 180 181 182 183 184 185
	exit 1
}

say () {
	say_color info "$*"
}

186 187 188 189 190 191 192 193 194
test "${test_description}" != "" ||
error "Test script did not set test_description."

if test "$help" = "t"
then
	echo "$test_description"
	exit 0
fi

195
exec 5>&1
196 197 198 199 200 201 202 203 204
if test "$verbose" = "t"
then
	exec 4>&2 3>&1
else
	exec 4>/dev/null 3>/dev/null
fi

test_failure=0
test_count=0
J
Junio C Hamano 已提交
205 206
test_fixed=0
test_broken=0
207
test_success=0
208

209 210
test_external_has_tap=0

211
die () {
212 213 214 215 216 217 218 219
	code=$?
	if test -n "$GIT_EXIT_OK"
	then
		exit $code
	else
		echo >&5 "FATAL: Unexpected exit with code $code"
		exit 1
	fi
220 221
}

222
GIT_EXIT_OK=
223
trap 'die' EXIT
224

225 226 227 228 229 230 231 232
# The semantics of the editor variables are that of invoking
# sh -c "$EDITOR \"$@\"" files ...
#
# If our trash directory contains shell metacharacters, they will be
# interpreted if we just set $EDITOR directly, so do a little dance with
# environment variables to work around this.
#
# In particular, quoting isn't enough, as the path may contain the same quote
233
# that we're using.
234 235 236
test_set_editor () {
	FAKE_EDITOR="$1"
	export FAKE_EDITOR
237 238
	EDITOR='"$FAKE_EDITOR"'
	export EDITOR
239 240
}

241 242 243 244 245 246 247 248 249 250 251
test_decode_color () {
	sed	-e 's/.\[1m/<WHITE>/g' \
		-e 's/.\[31m/<RED>/g' \
		-e 's/.\[32m/<GREEN>/g' \
		-e 's/.\[33m/<YELLOW>/g' \
		-e 's/.\[34m/<BLUE>/g' \
		-e 's/.\[35m/<MAGENTA>/g' \
		-e 's/.\[36m/<CYAN>/g' \
		-e 's/.\[m/<RESET>/g'
}

252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267
q_to_nul () {
	perl -pe 'y/Q/\000/'
}

q_to_cr () {
	tr Q '\015'
}

append_cr () {
	sed -e 's/$/Q/' | tr Q '\015'
}

remove_cr () {
	tr '\015' Q | sed -e 's/Q$//'
}

268 269 270
test_tick () {
	if test -z "${test_tick+set}"
	then
J
Junio C Hamano 已提交
271
		test_tick=1112911993
272 273 274
	else
		test_tick=$(($test_tick + 60))
	fi
J
Junio C Hamano 已提交
275 276
	GIT_COMMITTER_DATE="$test_tick -0700"
	GIT_AUTHOR_DATE="$test_tick -0700"
277 278
	export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
}
279

280 281 282 283 284 285 286 287
# Call test_commit with the arguments "<message> [<file> [<contents>]]"
#
# This will commit a file with the given contents and the given commit
# message.  It will also add a tag with <message> as name.
#
# Both <file> and <contents> default to <message>.

test_commit () {
288
	file=${2:-"$1.t"}
289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304
	echo "${3-$1}" > "$file" &&
	git add "$file" &&
	test_tick &&
	git commit -m "$1" &&
	git tag "$1"
}

# Call test_merge with the arguments "<message> <commit>", where <commit>
# can be a tag pointing to the commit-to-merge.

test_merge () {
	test_tick &&
	git merge -m "$1" "$2" &&
	git tag "$1"
}

305 306 307 308 309 310 311 312 313
# This function helps systems where core.filemode=false is set.
# Use it instead of plain 'chmod +x' to set or unset the executable bit
# of a file in the working directory and add it to the index.

test_chmod () {
	chmod "$@" &&
	git update-index --add "--chmod=$@"
}

314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338
# Use test_set_prereq to tell that a particular prerequisite is available.
# The prerequisite can later be checked for in two ways:
#
# - Explicitly using test_have_prereq.
#
# - Implicitly by specifying the prerequisite tag in the calls to
#   test_expect_{success,failure,code}.
#
# The single parameter is the prerequisite tag (a simple word, in all
# capital letters by convention).

test_set_prereq () {
	satisfied="$satisfied$1 "
}
satisfied=" "

test_have_prereq () {
	case $satisfied in
	*" $1 "*)
		: yes, have it ;;
	*)
		! : nope ;;
	esac
}

J
Junio C Hamano 已提交
339 340 341 342
# You are not expected to call test_ok_ and test_failure_ directly, use
# the text_expect_* functions instead.

test_ok_ () {
343
	test_success=$(($test_success + 1))
344
	say_color "" "ok $test_count - $@"
345 346
}

J
Junio C Hamano 已提交
347
test_failure_ () {
348
	test_failure=$(($test_failure + 1))
349
	say_color error "not ok - $test_count $1"
350
	shift
351
	echo "$@" | sed -e 's/^/#	/'
352
	test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
J
Junio C Hamano 已提交
353 354
}

J
Junio C Hamano 已提交
355 356
test_known_broken_ok_ () {
	test_fixed=$(($test_fixed+1))
357
	say_color "" "ok $test_count - $@ # TODO known breakage"
J
Junio C Hamano 已提交
358 359 360 361
}

test_known_broken_failure_ () {
	test_broken=$(($test_broken+1))
362
	say_color skip "not ok $test_count - $@ # TODO known breakage"
J
Junio C Hamano 已提交
363
}
J
Junio C Hamano 已提交
364 365

test_debug () {
366
	test "$debug" = "" || eval "$1"
367 368
}

369
test_run_ () {
370
	test_cleanup=:
371
	eval >&3 2>&4 "$1"
372
	eval_ret=$?
373
	eval >&3 2>&4 "$test_cleanup"
374 375 376
	return 0
}

377
test_skip () {
378
	test_count=$(($test_count+1))
379 380 381
	to_skip=
	for skp in $GIT_SKIP_TESTS
	do
382
		case $this_test.$test_count in
383 384 385 386
		$skp)
			to_skip=t
		esac
	done
387 388 389 390 391
	if test -z "$to_skip" && test -n "$prereq" &&
	   ! test_have_prereq "$prereq"
	then
		to_skip=t
	fi
392 393
	case "$to_skip" in
	t)
394
		say_color skip >&3 "skipping test: $@"
395
		say_color skip "ok $test_count: # skip $1"
396 397 398 399 400 401 402 403
		: true
		;;
	*)
		false
		;;
	esac
}

404
test_expect_failure () {
405
	test "$#" = 3 && { prereq=$1; shift; } || prereq=
406
	test "$#" = 2 ||
407
	error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
408
	if ! test_skip "$@"
409
	then
J
Junio C Hamano 已提交
410
		say >&3 "checking known breakage: $2"
411
		test_run_ "$2"
J
Junio C Hamano 已提交
412
		if [ "$?" = 0 -a "$eval_ret" = 0 ]
413
		then
J
Junio C Hamano 已提交
414
			test_known_broken_ok_ "$1"
415
		else
416
			test_known_broken_failure_ "$1"
417
		fi
418
	fi
419
	echo >&3 ""
420 421 422
}

test_expect_success () {
423
	test "$#" = 3 && { prereq=$1; shift; } || prereq=
424
	test "$#" = 2 ||
425
	error "bug in the test script: not 2 or 3 parameters to test-expect-success"
426
	if ! test_skip "$@"
427
	then
428 429 430 431 432 433 434 435
		say >&3 "expecting success: $2"
		test_run_ "$2"
		if [ "$?" = 0 -a "$eval_ret" = 0 ]
		then
			test_ok_ "$1"
		else
			test_failure_ "$@"
		fi
436
	fi
437
	echo >&3 ""
438 439
}

440
test_expect_code () {
441
	test "$#" = 4 && { prereq=$1; shift; } || prereq=
442
	test "$#" = 3 ||
443
	error "bug in the test script: not 3 or 4 parameters to test-expect-code"
444
	if ! test_skip "$@"
445
	then
446 447 448 449 450 451 452 453
		say >&3 "expecting exit code $1: $3"
		test_run_ "$3"
		if [ "$?" = 0 -a "$eval_ret" = "$1" ]
		then
			test_ok_ "$2"
		else
			test_failure_ "$@"
		fi
454
	fi
455
	echo >&3 ""
456 457
}

458 459 460
# test_external runs external test scripts that provide continuous
# test output about their progress, and succeeds/fails on
# zero/non-zero exit code.  It outputs the test output on stdout even
461
# in non-verbose mode, and announces the external script with "# run
462 463 464 465 466
# <n>: ..." before running it.  When providing relative paths, keep in
# mind that all scripts run in "trash directory".
# Usage: test_external description command arguments...
# Example: test_external 'Perl API' perl ../path/to/test.pl
test_external () {
467 468 469
	test "$#" = 4 && { prereq=$1; shift; } || prereq=
	test "$#" = 3 ||
	error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
470 471 472 473 474 475
	descr="$1"
	shift
	if ! test_skip "$descr" "$@"
	then
		# Announce the script to reduce confusion about the
		# test output that follows.
476
		say_color "" "# run $test_count: $descr ($*)"
477 478 479
		# Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
		# to be able to use them in script
		export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
480 481 482 483 484 485
		# Run command; redirect its stderr to &4 as in
		# test_run_, but keep its stdout on our stdout even in
		# non-verbose mode.
		"$@" 2>&4
		if [ "$?" = 0 ]
		then
486 487 488 489 490 491
			if test $test_external_has_tap -eq 0; then
				test_ok_ "$descr"
			else
				say_color "" "# test_external test $descr was ok"
				test_success=$(($test_success + 1))
			fi
492
		else
493 494 495 496 497 498
			if test $test_external_has_tap -eq 0; then
				test_failure_ "$descr" "$@"
			else
				say_color error "# test_external test $descr failed: $@"
				test_failure=$(($test_failure + 1))
			fi
499 500 501 502 503 504 505 506 507 508 509 510 511 512 513
		fi
	fi
}

# Like test_external, but in addition tests that the command generated
# no output on stderr.
test_external_without_stderr () {
	# The temporary file has no (and must have no) security
	# implications.
	tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
	stderr="$tmp/git-external-stderr.$$.tmp"
	test_external "$@" 4> "$stderr"
	[ -f "$stderr" ] || error "Internal error: $stderr disappeared."
	descr="no stderr: $1"
	shift
514
	say >&3 "# expecting no stderr from previous command"
515 516
	if [ ! -s "$stderr" ]; then
		rm "$stderr"
517 518 519 520 521 522 523

		if test $test_external_has_tap -eq 0; then
			test_ok_ "$descr"
		else
			say_color "" "# test_external_without_stderr test $descr was ok"
			test_success=$(($test_success + 1))
		fi
524 525
	else
		if [ "$verbose" = t ]; then
526
			output=`echo; echo "# Stderr is:"; cat "$stderr"`
527 528 529 530 531
		else
			output=
		fi
		# rm first in case test_failure exits.
		rm "$stderr"
532 533 534 535 536 537
		if test $test_external_has_tap -eq 0; then
			test_failure_ "$descr" "$@" "$output"
		else
			say_color error "# test_external_without_stderr test $descr failed: $@: $output"
			test_failure=$(($test_failure + 1))
		fi
538 539 540
	fi
}

J
Junio C Hamano 已提交
541 542 543 544 545 546 547 548 549 550 551 552 553 554
# This is not among top-level (test_expect_success | test_expect_failure)
# but is a prefix that can be used in the test script, like:
#
#	test_expect_success 'complain and die' '
#           do something &&
#           do something else &&
#	    test_must_fail git checkout ../outerspace
#	'
#
# Writing this as "! git checkout ../outerspace" is wrong, because
# the failure could be due to a segv.  We want a controlled failure.

test_must_fail () {
	"$@"
555
	test $? -gt 0 -a $? -le 129 -o $? -gt 192
J
Junio C Hamano 已提交
556 557
}

558 559 560 561 562 563 564 565 566 567 568 569 570 571 572 573
# Similar to test_must_fail, but tolerates success, too.  This is
# meant to be used in contexts like:
#
#	test_expect_success 'some command works without configuration' '
#		test_might_fail git config --unset all.configuration &&
#		do something
#	'
#
# Writing "git config --unset all.configuration || :" would be wrong,
# because we want to notice if it fails due to segv.

test_might_fail () {
	"$@"
	test $? -ge 0 -a $? -le 129 -o $? -gt 192
}

574 575 576 577 578 579 580 581 582 583 584 585 586 587 588 589 590
# test_cmp is a helper function to compare actual and expected output.
# You can use it like:
#
#	test_expect_success 'foo works' '
#		echo expected >expected &&
#		foo >actual &&
#		test_cmp expected actual
#	'
#
# This could be written as either "cmp" or "diff -u", but:
# - cmp's output is not nearly as easy to read as diff -u
# - not all diff versions understand "-u"

test_cmp() {
	$GIT_TEST_CMP "$@"
}

591 592 593 594 595 596 597 598 599 600 601 602 603 604 605 606 607 608 609 610 611
# This function can be used to schedule some commands to be run
# unconditionally at the end of the test to restore sanity:
#
#	test_expect_success 'test core.capslock' '
#		git config core.capslock true &&
#		test_when_finished "git config --unset core.capslock" &&
#		hello world
#	'
#
# That would be roughly equivalent to
#
#	test_expect_success 'test core.capslock' '
#		git config core.capslock true &&
#		hello world
#		git config --unset core.capslock
#	'
#
# except that the greeting and config --unset must both succeed for
# the test to pass.

test_when_finished () {
612 613
	test_cleanup="{ $*
		} && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
614 615
}

616
# Most tests can use the created repository, but some may need to create more.
617 618 619 620 621 622
# Usage: test_create_repo <directory>
test_create_repo () {
	test "$#" = 1 ||
	error "bug in the test script: not 1 parameter to test-create-repo"
	owd=`pwd`
	repo="$1"
623
	mkdir -p "$repo"
624
	cd "$repo" || error "Cannot setup test environment"
625
	"$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
626
	error "cannot run git init -- have you built things yet?"
627 628 629
	mv .git/hooks .git/hooks-disabled
	cd "$owd"
}
J
Junio C Hamano 已提交
630

631
test_done () {
632
	GIT_EXIT_OK=t
633 634
	test_results_dir="$TEST_DIRECTORY/test-results"
	mkdir -p "$test_results_dir"
635
	test_results_path="$test_results_dir/${0%.sh}-$$"
636 637 638 639 640 641 642

	echo "total $test_count" >> $test_results_path
	echo "success $test_success" >> $test_results_path
	echo "fixed $test_fixed" >> $test_results_path
	echo "broken $test_broken" >> $test_results_path
	echo "failed $test_failure" >> $test_results_path
	echo "" >> $test_results_path
J
Junio C Hamano 已提交
643 644 645

	if test "$test_fixed" != 0
	then
646
		say_color pass "# fixed $test_fixed known breakage(s)"
J
Junio C Hamano 已提交
647 648 649
	fi
	if test "$test_broken" != 0
	then
650
		say_color error "# still have $test_broken known breakage(s)"
651 652 653
		msg="remaining $(($test_count-$test_broken)) test(s)"
	else
		msg="$test_count test(s)"
J
Junio C Hamano 已提交
654
	fi
655
	case "$test_failure" in
656
	0)
657 658 659
		# Maybe print SKIP message
		[ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"

660 661 662 663
		if test $test_external_has_tap -eq 0; then
			say_color pass "# passed all $msg"
			say "1..$test_count$skip_all"
		fi
J
Johannes Schindelin 已提交
664 665 666 667 668

		test -d "$remove_trash" &&
		cd "$(dirname "$remove_trash")" &&
		rm -rf "$(basename "$remove_trash")"

669 670 671
		exit 0 ;;

	*)
672 673 674 675
		if test $test_external_has_tap -eq 0; then
			say_color error "# failed $test_failure among $msg"
			say "1..$test_count"
		fi
676

677 678 679 680 681 682
		exit 1 ;;

	esac
}

# Test the binaries we have just built.  The tests are kept in
683
# t/ subdirectory and are run in 'trash directory' subdirectory.
684
TEST_DIRECTORY=$(pwd)
685
if test -n "$valgrind"
686 687 688 689 690 691 692 693 694 695 696 697 698 699 700 701 702 703 704 705 706 707 708 709 710 711 712 713 714 715 716 717 718
then
	make_symlink () {
		test -h "$2" &&
		test "$1" = "$(readlink "$2")" || {
			# be super paranoid
			if mkdir "$2".lock
			then
				rm -f "$2" &&
				ln -s "$1" "$2" &&
				rm -r "$2".lock
			else
				while test -d "$2".lock
				do
					say "Waiting for lock on $2."
					sleep 1
				done
			fi
		}
	}

	make_valgrind_symlink () {
		# handle only executables
		test -x "$1" || return

		base=$(basename "$1")
		symlink_target=$TEST_DIRECTORY/../$base
		# do not override scripts
		if test -x "$symlink_target" &&
		    test ! -d "$symlink_target" &&
		    test "#!" != "$(head -c 2 < "$symlink_target")"
		then
			symlink_target=../valgrind.sh
		fi
719 720 721 722
		case "$base" in
		*.sh|*.perl)
			symlink_target=../unprocessed-script
		esac
723 724 725 726 727 728 729 730 731 732 733
		# create the link, or replace it if it is out of date
		make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
	}

	# override all git executables in TEST_DIRECTORY/..
	GIT_VALGRIND=$TEST_DIRECTORY/valgrind
	mkdir -p "$GIT_VALGRIND"/bin
	for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
	do
		make_valgrind_symlink $file
	done
734 735 736 737 738 739 740 741 742 743 744
	OLDIFS=$IFS
	IFS=:
	for path in $PATH
	do
		ls "$path"/git-* 2> /dev/null |
		while read file
		do
			make_valgrind_symlink "$file"
		done
	done
	IFS=$OLDIFS
745 746 747
	PATH=$GIT_VALGRIND/bin:$PATH
	GIT_EXEC_PATH=$GIT_VALGRIND/bin
	export GIT_VALGRIND
748 749 750 751 752 753 754 755 756 757 758 759 760 761 762 763 764 765
elif test -n "$GIT_TEST_INSTALLED" ; then
	GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
	error "Cannot run git from $GIT_TEST_INSTALLED."
	PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
	GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
else # normal case, use ../bin-wrappers only unless $with_dashes:
	git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
	if ! test -x "$git_bin_dir/git" ; then
		if test -z "$with_dashes" ; then
			say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
		fi
		with_dashes=t
	fi
	PATH="$git_bin_dir:$PATH"
	GIT_EXEC_PATH=$TEST_DIRECTORY/..
	if test -n "$with_dashes" ; then
		PATH="$TEST_DIRECTORY/..:$PATH"
	fi
766
fi
J
Johannes Schindelin 已提交
767
GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
J
Jeff King 已提交
768 769 770 771
unset GIT_CONFIG
GIT_CONFIG_NOSYSTEM=1
GIT_CONFIG_NOGLOBAL=1
export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
772

J
Jeff King 已提交
773 774
. ../GIT-BUILD-OPTIONS

775 776 777 778 779 780 781 782 783 784
if test -z "$GIT_TEST_CMP"
then
	if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
	then
		GIT_TEST_CMP="$DIFF -c"
	else
		GIT_TEST_CMP="$DIFF -u"
	fi
fi

785 786
GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
export GITPERLLIB
787 788 789
test -d ../templates/blt || {
	error "You haven't built things yet, have you?"
}
790

J
Jeff King 已提交
791
if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
792 793 794 795 796 797 798 799
then
	GITPYTHONLIB="$(pwd)/../git_remote_helpers/build/lib"
	export GITPYTHONLIB
	test -d ../git_remote_helpers/build || {
		error "You haven't built git_remote_helpers yet, have you?"
	}
fi

E
Eric Wong 已提交
800 801 802 803 804 805
if ! test -x ../test-chmtime; then
	echo >&2 'You need to build test-chmtime:'
	echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
	exit 1
fi

806
# Test repository
J
Johannes Schindelin 已提交
807
test="trash directory.$(basename "$0" .sh)"
808 809 810 811 812
test -n "$root" && test="$root/$test"
case "$test" in
/*) TRASH_DIRECTORY="$test" ;;
 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
esac
813
test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
814
rm -fr "$test" || {
815
	GIT_EXIT_OK=t
816 817 818 819
	echo >&5 "FATAL: Cannot prepare test area"
	exit 1
}

820
test_create_repo "$test"
821 822 823
# Use -P to resolve symlinks in our working directory so that the cwd
# in subprocesses like git equals our $PWD (for pathname comparisons).
cd -P "$test" || exit 1
824

825 826
this_test=${0##*/}
this_test=${this_test%%-*}
827 828 829 830 831 832 833 834 835 836 837 838
for skp in $GIT_SKIP_TESTS
do
	to_skip=
	for skp in $GIT_SKIP_TESTS
	do
		case "$this_test" in
		$skp)
			to_skip=t
		esac
	done
	case "$to_skip" in
	t)
839 840
		say_color skip >&3 "skipping test $this_test altogether"
		say_color skip "skip all tests in $this_test"
841 842 843
		test_done
	esac
done
844

845 846 847 848 849 850 851 852 853 854 855 856 857 858 859
# Provide an implementation of the 'yes' utility
yes () {
	if test $# = 0
	then
		y=y
	else
		y="$*"
	fi

	while echo "$y"
	do
		:
	done
}

860 861 862 863 864 865 866 867 868 869
# Fix some commands on Windows
case $(uname -s) in
*MINGW*)
	# Windows has its own (incompatible) sort and find
	sort () {
		/usr/bin/sort "$@"
	}
	find () {
		/usr/bin/find "$@"
	}
870 871 872
	sum () {
		md5sum "$@"
	}
873 874 875 876
	# git sees Windows-style pwd
	pwd () {
		builtin pwd -W
	}
877
	# no POSIX permissions
878
	# backslashes in pathspec are converted to '/'
879
	# exec does not inherit the PID
880 881 882
	;;
*)
	test_set_prereq POSIXPERM
883
	test_set_prereq BSLASHPSPEC
884
	test_set_prereq EXECKEEPSPID
885 886
	;;
esac
887

888
test -z "$NO_PERL" && test_set_prereq PERL
889
test -z "$NO_PYTHON" && test_set_prereq PYTHON
890

891 892 893
# test whether the filesystem supports symbolic links
ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
rm -f y